﻿#include "i2cSLA.h"

//静的メンバ関数の実体
bool i2cSLA::init_flag = true;

i2cSLA::i2cSLA(char adress)
	:SLAadress(adress)
{
	if (init_flag){
		init_flag = false;
		
		//従装置ｱﾄﾞﾚｽ設定 一斉呼び出し拒否
		TWAR = (SLAadress<<TWA0)|(0<<TWGCE);
		TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);
	}
}

i2cSLA::~i2cSLA()
{
}

void i2cSLA::action(char senddata,char* recievedata)
{
	//TWINTフラグが立ってないときmainに戻る
	if (!(TWCR & (1<<TWINT)))
		return;
	
	// TWINTがセットされているとき
	switch(TW_STATUS){
		case TW_ST_SLA_ACK:
		case TW_SR_SLA_ACK:
			break;
		case TW_SR_DATA_ACK:
		*recievedata = TWDR;
			break;
		case TW_ST_DATA_ACK:
		TWDR = senddata;
			break;
		default:
			break;
	}
	//TWINTフラグクリア
	TWCR = (1<<TWINT)|(1<<TWEA)|(1<<TWEN);
}